package data;

import java.util.GregorianCalendar;

/** GPSログのデータ */
public class GPSLocationData {
	public static final int Colum_日付 = 0;
	public static final int Colum_時刻 = 1;
	public static final int Colum_緯度 = 2;
	public static final int Colum_経度 = 3;
	public static final int Colum_速度 = 4;
	public static final int Colum_高度 = 5;
	public static final int LogColumCount = 6;

	public static final String sepalater = ",";

	/** データ用カラム */
	public static String getColum(){
		StringBuilder sbuf = new StringBuilder();
		sbuf.append("日付");
		sbuf.append(sepalater);
		sbuf.append("時刻");
		sbuf.append(sepalater);
		sbuf.append("緯度");
		sbuf.append(sepalater);
		sbuf.append("経度");
		sbuf.append(sepalater);
		sbuf.append("速度(km/h)");
		sbuf.append(sepalater);
		sbuf.append("高度(m)");
		return sbuf.toString();
	}
	
	public static GPSLocationData parse(String Line){
		String[] Elem = new String[LogColumCount];
		String[] in = Line.split(sepalater);
		for(int i=0;i<Elem.length;i++){
			if(in.length > i){
				Elem[i] = in[i];
 			} else {
 				Elem[i] = "";
 			}
		}
		return new GPSLocationData(Elem);
	}

	
	//個別要素
	public String 日付;
	public String 時刻;
	public String 緯度;
	public String 経度;
	public String 速度;
	public String 高度;
	
	private GPSLocationData(String[] Elem){
		this.日付 = Elem[Colum_日付];
		this.時刻 = Elem[Colum_時刻];
		this.緯度 = Elem[Colum_緯度];
		this.経度 = Elem[Colum_経度];
		this.速度 = Elem[Colum_速度];
		this.高度 = Elem[Colum_高度];
	};
	
	@Override
	public boolean equals(Object arg0) {
		if(arg0 instanceof GPSLocationData){
			return arg0.toString().equals(this.toString());
		}
		return false;
	}
	@Override
	public int hashCode() {
		return this.toString().hashCode();
	}
	@Override
	public String toString() {
		StringBuilder sbuf = new StringBuilder();
		sbuf.append(this.日付);
		sbuf.append(sepalater);
		sbuf.append(this.時刻);
		sbuf.append(sepalater);
		sbuf.append(this.緯度);
		sbuf.append(sepalater);
		sbuf.append(this.経度);
		sbuf.append(sepalater);
		sbuf.append(this.速度);
		sbuf.append(sepalater);
		sbuf.append(this.高度);
		return sbuf.toString();
	}
	public GPSPosition getGPSPosition() throws NumberFormatException{
		return new GPSPosition(this.緯度,this.経度,Double.parseDouble(this.高度));
	}
	
	
	public GregorianCalendar getDate() throws NumberFormatException{
		return GPSLocationData.getDate(this.日付,this.時刻);
	}
	public static GregorianCalendar getDate(String date,String time) throws NumberFormatException{
		String[] dateString = date.split("-");
		String[] timeString = time.split("-");
		int[] dateAndTimes = new int[6];
		for(int i=0;i<3;i++){
			dateAndTimes[i] = Integer.parseInt(dateString[i]);
			dateAndTimes[i+3] = Integer.parseInt(timeString[i]);
		}
		return new GregorianCalendar(dateAndTimes[0],dateAndTimes[1],dateAndTimes[2],dateAndTimes[3],dateAndTimes[4],dateAndTimes[5]);
	}
	
	
}
