package parser;
import data.GsdPointData;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;

import data.GPSLocationData;
import data.GPSPosition;

public class jsWriter {
	private static final File DEFAULTOUTPOUTFILE = new File("plotdata.js");

    public static final int Colum_日付 = 0;
    public static final int Colum_時刻 = 1;
    public static final int Colum_緯度 = 2;
    public static final int Colum_経度 = 3;
    public static final int Colum_速度 = 4;
    public static final int Colum_高度 = 5;
        
    public static ArrayList<GPSLocationData> parseGSDData(ArrayList<GsdPointData> dataList) {
        ArrayList<GPSLocationData> plist = new ArrayList<GPSLocationData>();
        for(GsdPointData element:dataList){
            GPSPosition pos = element.getLocation();
            StringBuilder dataLine = new StringBuilder();
            dataLine.append(element.getDateByStringFormat());
            dataLine.append(",");
            dataLine.append(element.getTimeByStringFormat());
            dataLine.append(",");
            dataLine.append(pos.get緯度());
            dataLine.append(",");
            dataLine.append(pos.get経度());
            dataLine.append(",");
            dataLine.append(element.getSpeed());
            dataLine.append(",");
            dataLine.append(pos.get高度());
            GPSLocationData data = GPSLocationData.parse(dataLine.toString());
            plist.add(data);
        }        
        return plist;
    }

	private String encode = "UTF8";
	private StringBuilder PointArrays;

	public jsWriter(ArrayList<GPSLocationData> datalist){
		this(datalist,true);
	}

	public jsWriter(ArrayList<GPSLocationData> datalist,boolean removeSomePoints){
		this.setArrays(datalist,removeSomePoints);
	}
	
	public void setEncode(String enc){
		this.encode = enc;
	}
	
	private void setArrays(ArrayList<GPSLocationData> datalist,boolean removeSomePoints){
		this.PointArrays = new StringBuilder();
		SimpleDateFormat timeFormat = new SimpleDateFormat("HH:mm:ss");
                
		int count = 0;
		long lastTime = 0;
		for(GPSLocationData data:datalist){
			if(removeSomePoints){
				//点を間引く場合
				String Date = timeFormat.format(data.getDate().getTime());
				long current = data.getDate().getTime().getTime();
				if(Date.endsWith("00") || (current-lastTime)>=5000 ){
					double[] point = data.getGPSPosition().getPositonByDoubleDegreeValue();
					//new google.maps.LatLng(35.44271333333333,139.64648833333334),
					this.PointArrays.append("\t\tnew google.maps.LatLng(");
					this.PointArrays.append(point[0]);
					this.PointArrays.append(",");
					this.PointArrays.append(point[1]);
					this.PointArrays.append("),\n");

					count++;
					lastTime = current;
				}
			} else {
				//間引かない場合
				double[] point = data.getGPSPosition().getPositonByDoubleDegreeValue();
				this.PointArrays.append("new google.maps.LatLng(");
				this.PointArrays.append(point[0]);
				this.PointArrays.append(",");
				this.PointArrays.append(point[1]);
				this.PointArrays.append("),\n");
				count++;
			}
		}
		if(this.PointArrays.length()>0){
			this.PointArrays.delete(this.PointArrays.length()-2, this.PointArrays.length()-1);
		}		
	}
	
        public void writeJsFile() throws IOException{
            writeJsFile(DEFAULTOUTPOUTFILE);
        }
        
	public void writeJsFile(File outputFile) throws IOException{
		PrintStream writer = new PrintStream(outputFile,this.encode);                
                writer.println("var trackCoordinates = [");
                writer.print(this.PointArrays);
                writer.println("];");
		writer.close();
	}
	
	public static File makeOutputFile(File inputFile){
		String path = inputFile.getPath();
		return new File(path.substring(0,path.lastIndexOf("."))+".js");
	}
	
	public static ArrayList<GPSLocationData> openHistoryFile(File inputFile) throws IOException{
		ArrayList<GPSLocationData> historys = new ArrayList<GPSLocationData>();
		BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(inputFile)));
		String Line = reader.readLine();
		while((Line = reader.readLine()) != null){
			GPSLocationData data = GPSLocationData.parse(Line);
			if(data != null){
				historys.add(data);
			}
		}
		reader.close();
		return historys;
	}
	

}
